#include <Sentry.h>
#include <Servo.h>
#include <Wire.h>

Sentry1 sentry1(0x60);
Servo servo_2;
Servo servo_3;
Servo servo_4;
Servo servo_5;
Servo servo_6;
Servo servo_7;
Servo servo_8;
volatile int count;
volatile int s2;
volatile int s3;
volatile int s4;
volatile int sz1;
volatile int bl1;

sentry_object_t param;

void A(){
  if (digitalRead(9) == LOW) {
    switch (bl1) {  
     case 0:
      bl1 = bl1 + 1;
      for (int i = 1; i <= 2; i = i + (1)) {
      servo_2.writeMicroseconds(1500);
      delay(1000);
      servo_2.writeMicroseconds(1800);
      delay(1000);
      servo_2.writeMicroseconds(1200);
      delay(1000);
      }
      servo_2.writeMicroseconds(1500);
      delay(1000);
      break;
     case 1:
      bl1 = bl1 + 1;
      servo_3.writeMicroseconds(1720);
      delay(1000);
      for (int i = 1; i <= 2; i = i + (1)) {
        servo_4.writeMicroseconds(1833);
        delay(1000);
        servo_4.writeMicroseconds(1700);
        delay(1000);
        servo_4.writeMicroseconds(1833);
        delay(1000);
        servo_4.writeMicroseconds(1700);
        delay(1000);
      }
      servo_3.writeMicroseconds(1500);
      servo_4.writeMicroseconds(1500);
      break;
     case 2:
      bl1 = bl1 + 1;
      servo_3.writeMicroseconds(1720);
      servo_4.writeMicroseconds(1833);
      delay(1000);
      servo_7.writeMicroseconds(2166);
      servo_8.writeMicroseconds(834);
      delay(500);
      servo_5.writeMicroseconds(2100);
      delay(3000);
      servo_5.writeMicroseconds(1500);
      servo_7.writeMicroseconds(1500);
      servo_8.writeMicroseconds(1500);
      delay(1000);
      servo_3.writeMicroseconds(1500);
      servo_4.writeMicroseconds(1500);
      delay(2000);
      break;
     case 3:
      bl1 = bl1 + 1;
      for (int i = 1; i <= 3; i = i + (1)) {
        servo_6.writeMicroseconds(1700);
        delay(2000);
        servo_6.writeMicroseconds(1300);
        delay(2000);
      }
      break;
     case 4:
      bl1 = 0;
      for (int i = 1; i <= 2; i = i + (1)){
        servo_8.writeMicroseconds(650);
        servo_7.writeMicroseconds(2150);
        delay(1000);
        servo_8.writeMicroseconds(1500);
        servo_7.writeMicroseconds(1500);
        delay(1000);
      }
      break;
    }
  }
}
  
void setup(){
  Wire.begin();

  servo_2.attach(2);
  s2 = 1500;
  servo_3.attach(3);
  s3 = 1500;
  servo_4.attach(4);
  s4 = 1800;
  servo_5.attach(5);
  servo_6.attach(6);
  servo_7.attach(7);
  servo_8.attach(8);
  while (SENTRY_OK != sentry1.begin(&Wire)) {yield();}
  delay(1000);
  sentry1.CameraSetAwb(kAutoWhiteBalance);
  sentry1.VisionBegin(Sentry1::kVisionBlob);
  param.width = 10;
  param.height = 10;
  param.label = Sentry1::kColorRed;
  sentry1.SetParam(Sentry1::kVisionBlob,&param,3);
  
  servo_2.writeMicroseconds(1500);
  servo_3.writeMicroseconds(1500);
  servo_4.writeMicroseconds(1500);
  servo_5.writeMicroseconds(1500);
  servo_6.writeMicroseconds(1500);
  servo_7.writeMicroseconds(1500);
  servo_8.writeMicroseconds(1500);
  delay(1000);
  pinMode(9, INPUT);
  count = 1;
  bl1 = 0;
}

void loop(){
  count = sentry1.GetValue(Sentry1::kVisionBlob, kStatus);
  for (int i = (1); i <= (count); i = i + (1)) {
    if ((sentry1.GetValue(Sentry1::kVisionBlob,kLabel,i)==Sentry1::kColorRed)) {
      servo_4.writeMicroseconds(1800);
      if ((sentry1.GetValue(Sentry1::kVisionBlob,kXValue,i) <= 55 && sentry1.GetValue(Sentry1::kVisionBlob,kXValue,i) >= 45) && (sentry1.GetValue(Sentry1::kVisionBlob,kYValue,i) <= 55 && sentry1.GetValue(Sentry1::kVisionBlob,kYValue,i) >= 45)) {
        while (!(digitalRead(9) == LOW)){
          s3 = s3 + 1.5;
          servo_3.writeMicroseconds(s3);
          s4 = s4 + 1.5;
          servo_4.writeMicroseconds(s4);
          delay(10);
        }
        bl1 = bl1 + 1;
        servo_8.writeMicroseconds(650);
        servo_7.writeMicroseconds(2150);
        delay(3000);
        for (sz1 = s3;sz1 >= 1750;sz1 -= 1){
          servo_3.writeMicroseconds(sz1);
          delay(10);
        }
        for (sz1 = s4;sz1 >= 1700;sz1 -= 1){
          servo_4.writeMicroseconds(sz1);
          delay(10);
        }
        delay(3000);
          servo_2.writeMicroseconds(2150);
          delay(2000);
          servo_7.writeMicroseconds(1500);
          servo_8.writeMicroseconds(1500);
          delay(2000);
          servo_2.writeMicroseconds(1500);
          servo_3.writeMicroseconds(1500);
          servo_4.writeMicroseconds(1500);
          s3 = 1500;
          s4 = 1800;
          
      } else if (sentry1.GetValue(Sentry1::kVisionBlob,kXValue,i) > 55) {
        s2 = s2 - 3;
        servo_2.writeMicroseconds(s2);
      } else if (sentry1.GetValue(Sentry1::kVisionBlob,kXValue,i) < 45) {
        s2 = s2 + 3;
        servo_2.writeMicroseconds(s2);
      } else if (sentry1.GetValue(Sentry1::kVisionBlob,kYValue,i) > 55) {
        s3 = s3 + 3;
        servo_3.writeMicroseconds(s3);
      } else if (sentry1.GetValue(Sentry1::kVisionBlob,kYValue,i) < 45) {
        s3 = s3 - 3;
        servo_3.writeMicroseconds(s3);
      }
    }   
  }
  A();
}
